      PROGRAM SUPCRT
C--------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/AQ/ A1(10),A2(10),A3(10),A4(10),THETA(10),ABAR(10),
     1CBAR(10),DBAR(10), OMEGA(10),HI(10),SI(10),GI(10),HIPT(10),
     2SIPT(10),GIPT(10),VIPT(10),CPIPT(10)
      COMMON/ELECT/ Q,U,W,X,Y,Z,N
      COMMON/GZ/ AG(5),BG(5),CG(5),HG(5),SG(5),GG(5),HGPT(5),SGPT(5),
     1 GGPT(5),VG(5),DG(5),EG(5)
      COMMON/COND/ P,TC,TK
      COMMON/NMBR1/NM,NI,NG,NW,NIT,NMT,NGT,NP,NPW
      COMMON/NMBR2/IL
      COMMON/SWIT/ KK
      COMMON/HEAD/TITL(10),LNAME(20,4),AN(20)
      COMMON/OMG/OMEGA5(10)
      COMMON/DEX/IND(20),CPLIM(20),MIND(10),IIND(10),IGND(10)
      COMMON /PNCH/ IPUN
      COMMON/END/NCURV
      COMMON/DAT/NECHO
      COMMON/CP/NOCP
      COMMON /ALPHA/ A(9,7),AL,BET,GAM,B0,C,D,E,BB0,B1,B2,B4
      COMMON /CRIT/ TCRIT(9),PCRIT(9)
      COMMON /SH/TSAV
      COMMON /XGAS/R
      COMMON/IPRINT/NOPRIN
      COMMON/IO/PLTUN,RXNUN,ICNUN,INPT
      COMMON/GASS/ANG(2),XCO2,GASCOF(2),ISOL
      COMMON/PRIN/ICON,IGAS,ISW,NPT
      COMMON/INT2/NTHRU,XMIN,XINC,XMAX
      COMMON/EKILL/ILBLNK,TEPS,PEPS,EPSI
      COMMON/BUG/IBUG
      COMMON/XPF/XPFPT
C     ******************************************************************
C
C               PROGRAM SUPCRT
C               CALCULATES THERMODYNAMIC PROPERTIES OF REACTIONS
C               FOR MINERALS, IONS, GASES AND WATER
C
C               WRITTEN BY J.V. WALTHER AND D.H. KIRKHAM 1975
C               FOR THE CDC 7600
C
C               EXTENDED BY J. M. DELANEY AND G. C. FLOWERS
C               1976-1977
C
C               MODIFIED 1977 TO BE COMPATIBLE WITH 6000 SERIES
C               HARDWARE AND CORE INITIALIZATION TO ZERO
C
C                  (LAST CHANGES APRIL 1977)
C
C      *************** REVISED 1981 - BY G. C. FLOWERS *****************
C                 NEW EQUATION OF STATE FOR H2O
C            BY HAAR, GALLAGHER AND KELL, 1979, NATL BUR STANDARDS
C      *****************************************************************
C
C               CONVERTED FOR EXTERNAL I/O CONTROL BY C. R. KARISH,
C                   NOVEMBER 1985
C
C
C               CONVERTED FOR GAS STANDARD STATES AT P & T, NON-IDEAL
C                   H2O-CO2 MIXTURES (KERRICK & JACOBS) AND T-X
C                          DIAGRAMS BY JOHN WINTER 1/89
C
C----------------------------------------------------------------------
C
C(ICON,REXN,DATABASE,OUTPUT,OUTPLT,SUPDIA,SUPEQA,FLAGS)
      INTEGER PLTUN,RXNUN,ICNUN,FLAGS(2),INPT
C     CHARACTER*25 OUTPLT, OUTPUT, REXN, DATABASE, ICON, SUPDIA, SUPEQA
      CHARACTER*25 FILEX,REXN
C     CHANGE IBUG TO 1 FOR DEBUGGING SUBROUTINE ENTER STATEMENTS
      IBUG=0
      PLTUN = 9
      RXNUN = 10
      ICNUN = 13
      NOPRIN=0
      ILBLNK=0
      flags(1) = 0
      flags(2) = 0
      IZZZ=0
      WRITE(*,3000)
 3000 FORMAT(//
     1'          PROGRAM SUPCRT 2'/
     2'          CALCULATES THERMODYNAMIC PROPERTIES OF REACTIONS'/
     3'          FOR MINERALS, IONS, GASES AND WATER'///)
      WRITE(*,101)
  101 FORMAT(' IS THE DATA FROM: 1) A FILE  2) KEYBOARD  ?    ')
      READ(*,*)INPT
      WRITE(*,15)
   15 FORMAT(' FILENAME FOR OUTPUT??   ')
      READ(*,93) FILEX
   93 FORMAT(A25)
      OPEN(3, FILE=FILEX, STATUS='NEW', ERR=23)
c   extra ASCII output file in simplified format for ease in plotting
      OPEN (UNIT=PLTUN, FILE='outplt', STATUS='NEW', ERR=24)
c   note:  UNIT 4 is used elsewhere in supcrt.
      IF(INPT.EQ.2) RXNUN=5
      IF (RXNUN.NE.5) THEN
         WRITE(*,102)
  102    FORMAT(' FILENAME FOR INPUT??   ')
         READ(*,93) REXN
         OPEN (UNIT=RXNUN, FILE=REXN, STATUS='OLD', ERR=26)
C        OPEN (UNIT=ICNUN, FILE='icon', STATUS='OLD', ERR=25)
      END IF
C@@@ PC specific:  Look for the database in the current working directory,
C                  then in c:\lib, then in c:/lib (SH syntax).
      OPEN (UNIT=12, FILE='magic.dat', STATUS='OLD', ERR=20)
      GO TO 1
   20 OPEN (UNIT=12, FILE='c:\lib\magic.dat', STATUS='OLD', ERR=21)
      GO TO 1
   21 OPEN (UNIT=12, FILE='c:\lib\magic.dat', STATUS='OLD', ERR=22)
c   set default values for the first line of the icon file
    1 CONTINUE
      IF(IZZZ.EQ.1) WRITE(3,555)
  555 FORMAT(//,130(1H*),//)
      IZZZ=1
      ISTP=0
      NPW=0
      IF(INPT.EQ.1) GOTO 75
      WRITE(*,1000)
      READ(*,2000) (TITL(I), I=1,10)
      IF (TITL(1).EQ.'STOP    ') GO TO 3
      IF (TITL(1).EQ.'DEBUG   ') IBUG=1
      ICON=0
      WRITE(*,1010)
      READ(*,*) NM, NI, NG
      WRITE(*,1020)
      READ(*,*) NW
      IF(NW.EQ.0) GO TO 4
      WRITE(*,1040)
      READ(*,*) NPW
      GO TO 5
    4 NPW=0
    5 CONTINUE
      WRITE(*,1030)
      READ(*,*) NCURV
      NCURV=NCURV-1
      IF(NCURV.EQ.0) GO TO 50
      WRITE(*,1035)
      READ(*,*)ISOL
      IF(ISOL.NE.2) GO TO 873
      WRITE(*,*) ' ENTER P(fluid)/P(total)  '
      READ(*,*) XPFPT
  873 WRITE(*,1036)
      READ(*,*)NECHO
   50 CONTINUE
      GOTO 79
   75 READ (RXNUN,10,END=3) (TITL(I),I=1,10)
      IF (TITL(1).EQ.'STOP    ') GO TO 3
      IF (TITL(1).EQ.'DEBUG   ') IBUG=1
   76 CONTINUE
   10 FORMAT(10A8)
    2 CONTINUE
C     ------------------------------------------------------------------
C     NM = NO. OF MINERALS
C     NI = NO. OF IONS
C     NG = NO. OF GASES
C     NW = 1 IF H2O IN REACTION, 0 IF NOT
C     IL = NO. OF SPECIES IN REACTION
C     ------------------------------------------------------------------
      READ(RXNUN,*)NM,NI,NG,NW,NPW,NCURV,ISOL,NECHO
      NCURV=NCURV-1
C
C     IPUN = 1  PUNCH LOG K FOR PROG DIAGRAM
C     IPUN = 2  PUNCH G FOR PROG EQUILAS
C     IF (IPUN.EQ.1.OR.FLAGS(1).NE.0)
C    *    OPEN (UNIT=4, FILE='supdia', STATUS='NEW')
C     IF (IPUN.EQ.2.OR.FLAGS(2).NE.0)
C    *    OPEN (UNIT=15, FILE='supeqa', STATUS='NEW')
C     NCURV = 1  FIND UNIVARIANT CURVE AT GIVEN P*S (SET ICON = 1)
C     NECHO=1  DATA ECHO
C     NPW = 1 (OPTIONAL) PRINT STATEMENT ACKNOWLEDGING USE OF HIGH
C              PRESSURE H2O PROPERTIES ABOVE 10 KB
   79 CONTINUE
      IL=NM+NI+NG+NW
      NMS=1
      NMT=NM
      CALL LINEUP
      IF(INPT.EQ.2) GOTO 60
      IF(NCURV.EQ.1.AND.ISOL.EQ.2) READ(RXNUN,*) XPFPT
      IF(NCURV.EQ.1.AND.ISOL.EQ.3) READ(RXNUN,*) XMIN,XMAX,XINC
   60 CONTINUE
      KK=0
      CALL SUMREF(flags)
      KK=1
C     ------------------------------------------------------------------
      IF (NCURV.EQ.1) THEN
           CALL UNIV(ISTP)
      ENDIF
      IF (ISTP.EQ.1) GO TO 1
   54 CONTINUE
      CALL PTGET (ISTP)
      NOCP=0
      KK=1
      IF (ISTP.EQ.1) GO TO 1
      CALL SUMREF(flags)
 1000 FORMAT(' TITLE=????   IF TITLE=''STOP'', ROUTINE EXITS'/)
 1010 FORMAT(' LIST: #MINERALS, #AQ. SPECIES, #GASES IN REACTION'
     1' (IGNORE LIQUID WATER)'/)
 1020 FORMAT(' IS LIQUID H20 IN THE REACTION? 1=YES, 0=NO.     ')
 1030 FORMAT(' DO YOU WANT TO:'/
     1'     1) CREATE TABLES OF THERMODYNAMIC DATA'/
     2'     2) SOLVE FOR T(EQ) AT A SERIES OF P''S'/)
 1035 FORMAT(' DO YOU WANT TO SOLVE FOR T(EQ) FOR:'/
     15X,' 1) SOLID-SOLID OR SOLID+LIQUID WATER REACTIONS'/
     210X,' OR SOLID+GAS REACTIONS WITHOUT FUGACITY IN THE'/
     310X,' LOG K EXPRESSION (THIS IS NORMAL EXECUTION)'/
     45X,' 2) SOLIDS+SINGLE GAS AT P AND T'/
     55X,' 3) T-XCO2 EQM--MUST USE STEAM(1301), NOT LIQ. H2O'/
     610X,' ---USES KERRICK&JACOBS PROPS FOR CO2-H2O MIXTURES'/)
 1036 FORMAT(' DO YOU WANT A TEMPERATURE SEARCH ECHO?   1=YES  0=NO ')      00170100
 1040 FORMAT(' ARE YOU DEALING WITH WATER AT P>10 KB? 1=YES 0=N0.  ')
 2000 FORMAT(10A8)
      GO TO 54
   22 WRITE (*,*) 'Could not open file MAGIC.DAT.  Exiting.'
      GO TO 3
   23 WRITE (*,*) 'File OUTPUT exists, or cannot be opened.  Exiting.'
      GO TO 3
   24 WRITE (*,*) 'File OUTPLT exists, or cannot be opened.  Exiting.'
      GO TO 3
   25 WRITE (*,*) 'Could not open file ICON.  Exiting.'
      GO TO 3
   26 WRITE (*,*) 'Could not open file REXN.  Exiting.'
    3 STOP
      END
      SUBROUTINE LINEUP
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/AQ/ A1(10),A2(10),A3(10),A4(10),THETA(10),ABAR(10),
     1CBAR(10),DBAR(10), OMEGA(10),HI(10),SI(10),GI(10),HIPT(10),
     2SIPT(10),GIPT(10),VIPT(10),CPIPT(10)
      COMMON/ELECT/ Q,U,W,X,Y,Z,N
      COMMON/GZ/ AG(5),BG(5),CG(5),HG(5),SG(5),GG(5),HGPT(5),SGPT(5),
     1 GGPT(5),VG(5),DG(5),EG(5)
      COMMON/HEAD/TITL(10),LNAME(20,4),AN(20)
      COMMON/OMG/OMEGA5(10)
      COMMON/DEX/IND(20),CPLIM(20),MIND(10),IIND(10),IGND(10)
      COMMON /PNCH/ IPUN
      COMMON/NMBR1/NM,NI,NG,NW,NIT,NMT,NGT,NP,NPW
      COMMON/NMBR2/IL
      COMMON/DAT/NECHO
      COMMON/MN/AM(10),BM(10),CM(10),DM(10),EM(10),HM(10),SM(10),
     1GM(10),HMPT(10),SMPT(10),GMPT(10),VOLM(10),CPPT(10)
      COMMON/TRAN/AT1(10),BT1(10),CT1(10),DT1(10),ET1(10),
     1HT1(10),TT1(10),VT1(10),AT2(10),BT2(10),CT2(10),DT2(10),ET2(10),
     2HT2(10),TT2(10),VT2(10),AT3(10),BT3(10),CT3(10),DT3(10),ET3(10),
     3HT3(10),TT3(10),VT3(10),AT4(10),BT4(10),CT4(10),DT4(10),ET4(10),
     4HT4(10),TT4(10),VT4(10),AT5(10),BT5(10),CT5(10),DT5(10),ET5(10),
     5HT5(10),TT5(10),VT5(10),SLOPE(10,10),VRFTR(10),
     6NOTR(10),NINI(20),NTR
      COMMON /IO/PLTUN,RXNUN,ICNUN,INPT
      COMMON/GASS/ANG(2),XCO2,GASCOF(2),ISOL
      COMMON/BUG/IBUG
      INTEGER PLTUN,RXNUN,ICNUN,INPT
      INTEGER SNAM,SNAM2
      DIMENSION AQ(20),MNFOR(8)
      DIMENSION NID(20)
C     CHARACTER*4 NNAME1,NNAME2
C     DATA NNAME1,NNAME2/'WATE','R   '/

C
C     SUBROUTINE TO READ DATA ARRAY OF COEFFICIENTS FOR GASSES,MINERALS,
C     AND AQUEOUS SPECIES,  PICK OUT THE INDEX NUMBERS READ IN, AND
C     SET UP THE REACTION FOR SUPCRT
C
C     ====================  INDEXING NOTES   =====================
C
C     ID = COUNTER ON ALL REACTANTS AND PRODUCTS
C     IR = COUNTER ON MINS, IONS, AND GASSES  (MIN COUNT INCLUDES
C             TRANSITION (1500) MINERALS)
C     IT = COUNTER ON TRANSITION MINERALS ONLY
C     IL = TOTAL NO OF REACTANTS AND PRODUCTS
C
C
C     READ INDEX NUMBERS AND REACTION COEFFICIENTS
C
C     READ (10,1000)(AQ(I),NID(I),I=1,IL)
      IF(IBUG.EQ.1) WRITE(*,*) ' ENTERING LINEUP'
      NX=NM+NI+NG
      IF(INPT.EQ.2) GOTO 700
      READ (RXNUN,*)(AQ(I),NID(I),I=1,IL)
      GOTO 2053
  700 CONTINUE
      WRITE(*,3000)
 3000 FORMAT(' LIST REACTION COEFFICIENTS (REAL,AND NEG. FOR REACTANTS)'
     1/' AND INDEX NUMBERS(INTEGER) FOR MINERALS,IONS AND GASSES')
      DO 2050 I=1,NX
      WRITE(*,2051)I
 2051 FORMAT(' ENTER COEFFICIENT AND INDEX # FOR PHASE  ',I2,3X)
      READ(*,*) AQ(I),NID(I)
 2050 CONTINUE
 2055 CONTINUE
      IF(NW.EQ.0) GO TO 2053
      IF(NX.EQ.0)I=0
      I=I+1
      WRITE(*,2052)
 2052 FORMAT(' ENTER COEFFICIENT FOR WATER    ')
      READ(*,*) AQ(IL)
      NID(IL)=0
 2053 CONTINUE
      IF(NX.EQ.0)GO TO 401
C
C     SET CONSTANTS
C
C     ITM=NO. OF NON TRAN MINERALS IN DAT BNK
C     ITI=NO. OF IONS IN DAT BNK
C     ITG=NO. OF GASES IN DAT BNK
C     ITRN=NO. OF TRANS MINERALS IN DATBNK
C   The next two lines initializes ITM, ITI, ITG, and ITRN by reading
C       /work/geochem/Bin/T76.
C     REWIND 11
C     READ(11,1200) ITM,ITI,ITG,ITRN
C##### Mineral counts now come from the database file itself. --crk
      REWIND 12
      READ(12,1201) ITM,ITI,ITG,ITRN
      BCON=1.0E-3
      CCON=1.0E+5
      DCON=1.0E3
      ECON=1.0E-5
      A2CON=1.0E-5
      A3CON=1.0E-2
      A4CON=1.0E-5
      ANG(1)=0.0
      ANG(2)=0.0
      GASCOF(1)=1.0
      GASCOF(2)=1.0
C
C
C     READ MINERALS FROM DATA AND SAVE THOSE NEEDED FOR THE REACTION
C
C     REWIND 12
      ID=0
      IR=0
      IRSAV=0
      WRITE(*,6986)
      WRITE(*,*)' READ THE FOLLOWING DATA.  SUPCRIT WILL CALCULATE'
      WRITE(*,*) '    EVEN IF IMPORTANT DATA ARE MISSING!!'
      WRITE(*,6986)
      WRITE(*,2001) (TITL(I),I=1,9)
 2001 FORMAT(//,1H ,9A8,//)
      WRITE(*,6975)
      IF(NM.EQ.0) GO TO 33
      WRITE(*,7975)
      WRITE(*,6979)
C       READ(12,14567)
 6986 FORMAT(////)
   33 CONTINUE
      DO 100 I=1,ITM
      READ (12,4599)NO,MN1,MN2,MN3,MN4,
     1 (MNFOR(IK),IK=1,8),GMN,HMN,SMN,VMN,HA,HB,HC,HD,HE
 4599 FORMAT(I4,5X,3A4,A3,5X,8A4,/,5X,4F15.0,/,5X,5F10.0)
      READ(12,1100) CPBLK
      IF(NM.EQ.0) GO TO 100
      DO 50 N=1,IL
      IF(NO.NE.NID(N)) GO TO 50
   40 CONTINUE
      WRITE(*,6969) NO,MN1,MN2,MN3,MN4,
     1(MNFOR(IK),IK=1,8),
     1GMN,HMN,SMN,VMN,HA,HB,HC,HD,HE
      ID=ID+1
      IR=IR+1
      LNAME(ID,1)=MN1
      LNAME(ID,2)=MN2
      LNAME(ID,3)=MN3
      LNAME(ID,4)=MN4
      IND(ID)=NID(N)
      AN(ID)=AQ(N)
      GM(IR)=GMN
      HM(IR)=HMN
      SM(IR)=SMN
      AM(IR)=HA
      BM(IR)=HB*BCON
      CM(IR)=HC*CCON
      DM(IR)=HD*DCON
      EM(IR)=HE*ECON
      VOLM(IR)=VMN
      MIND(IR)=ID
      CPLIM(ID)=CPBLK
      IRSAV=IR
   50 CONTINUE
  100 CONTINUE
      IR=0
C
C     READ AQUEOUS DATA AND SAVE THOSE SPECIES NEEDED FOR REACTION
C
      IF(NI.EQ.0) GO TO 22
      WRITE(*,6977)
       WRITE(*,6980)
   22 CONTINUE
      DO 200 I=1,ITI
      READ (12,2000)
     1NO,SNAM,SNAM2,GSP,HSP,SSP,A1SP,A2SP,A3SP,A4SP,DABSP,CBSP,THSP,
     1 OMSP
      IF(NI.EQ.0) GO TO 200
      DO 150 N=1,IL
      IF(NO.NE.NID(N))  GO TO 150
  140 CONTINUE
      WRITE(*,6970)NO,SNAM,SNAM2,GSP,HSP,SSP,A1SP,A2SP,A3SP,A4SP,
     1DABSP,CBSP,THSP,OMSP
      ID=ID+1
      IR=IR+1
      LNAME(ID,1)=SNAM
      LNAME(ID,2)=SNAM2
      IND(ID)=NID(N)
      IIND(IR)=ID
      AN(ID)=AQ(N)
      A1(IR)=A1SP
      A2(IR)=A2SP*A2CON
      A3(IR)=A3SP*A3CON
      A4(IR)=A4SP*A4CON
      ABAR(IR)=DABSP
      CBAR(IR)=CBSP
      THETA(IR)=THSP
      DBAR(IR)=THSP
      OMEGA5(IR)=OMSP
      OMEGA(IR)=OMSP*(-1.0E+5)
      SI(IR)=SSP
      HI(IR)=HSP
      GI(IR)=GSP
  150 CONTINUE
  200 CONTINUE
C
C     READ GAS DATA AND SAVE THOSE NEEDED FOR REACTION
C
      IR=0
      IF(NG.EQ.0) GO TO 23
      WRITE(*,6976)
       WRITE(*,6979)
   23 CONTINUE
      DO 300 I=1,ITG
      READ (12,4599)NO,MN1,MN2,MN3,MN4,
     1 (MNFOR(IK),IK=1,8),GMN,HMN,SMN,VV,HA,HB,HC,HD,HE
      READ(12,1100) CPBLK
      IF(NG.EQ.0) GO TO 300
      DO 250 N=1,IL
      IF(NO.NE.NID(N))  GO TO 250
  240 CONTINUE
      WRITE(*,6972)NO,MN1,MN2,MN3,MN4,(MNFOR(L),L=1,8),GMN,HMN,
     1 SMN,VV,HA,HB,HC,HD,HE
      ID=ID+1
      IR=IR+1
      LNAME(ID,1)=MN1
      LNAME(ID,2)=MN2
      LNAME(ID,3)=MN3
      LNAME(ID,4)=MN4
      IND(ID)=NID(N)
      IGND(IR)=ID
      AN(ID)=AQ(N)
C   THE FOLLOWING 4 LINES LOAD /GAS/ FOR T-XCO2 OR GAS AT P&T
      KG=NO-1300
      IF(KG.EQ.5.AND.ISOL.EQ.3) ANG(1)=AQ(N)
      IF(KG.EQ.1.AND.ISOL.EQ.3) ANG(2)=AQ(N)
      IF(ISOL.EQ.2) ANG(1)=AQ(N)
      GG(IR)=GMN
      HG(IR)=HMN
      SG(IR)=SMN
      VG(IR)=VV
      AG(IR)=HA
      BG(IR)=HB*BCON
      CG(IR)=HC*CCON
      DG(IR)=HD*DCON
      EG(IR)=HE*ECON
      CPLIM(ID)=CPBLK
  250 CONTINUE
  300 CONTINUE
C
C     READ MINERALS WITH PHASE TRANSITIONS OR PSUEDO TRANSITIONS
C
      IR=IRSAV
      NTR=0
      IF(ID.EQ.(IL-NW)) GO TO 310
      WRITE(*,6978)
       WRITE(*,6979)
       WRITE(*,6981)
       WRITE(*,6982)
  310 CONTINUE
      DO 400 I=1,ITRN
      READ (12,1600)NO,MN1,MN2,MN3,MN4,
     1(MNFOR(IK),IK=1,8),GMN,HMN,SMN,VMN,HA,HB,HC,HD,HE,TTRN1,
     1HTRN1,VTR1,SLOP1
      READ (12,2500)
     1 NO,HA1,HB1,HC1,HD1,HE1,TTRN2,HTRN2,VTR2,SLOP2
      NNTN=1
      IF(TTRN2.LE.0.0) GO TO 405
      READ (12,2500)
     1 NO,HA2,HB2,HC2,HD2,HE2,TTRN3,HTRN3,VTR3,SLOP3
      NNTN=2
      IF(TTRN3.LE.0.0) GO TO 405
      READ(12,2500) NO,HA3,HB3,HC3,HD3,HE3,TTRN4,HTRN4,VTR4,SLOP4
      NNTN=3
      IF(TTRN4.LE.0.0) GO TO 405
      READ(12,2500) NO,HA4,HB4,HC4,HD4,HE4,TTRN5,HTRN5,VTR5,SLOP5
      NNTN=4
      IF(TTRN5.LE.0.0) GO TO 405
      READ(12,2500) NO,HA5,HB5,HC5,HD5,HE5
      NNTN=5
  405 CONTINUE
      READ(12,1100)  CPBLK
      DO 450 N=1,IL
      IF(NO.NE.NID(N)) GO TO 450
  440 CONTINUE
      WRITE(*,6969)NO,MN1,MN2,MN3,MN4,(MNFOR(L),L=1,8),GMN,HMN,
     1VMN,HA,HB,HC,HD,HE
      NTR=NTR+1
      ID=ID+1
      IR=IR+1
      IT=NTR
      LNAME(ID,1)=MN1
      LNAME(ID,2)=MN2
      LNAME(ID,3)=MN3
      LNAME(ID,4)=MN4
      IND(ID)=NID(N)
      AN(ID)=AQ(N)
      GM(IR)=GMN
      HM(IR)=HMN
      SM(IR)=SMN
      AM(IR)=HA
      BM(IR)=HB*BCON
      CM(IR)=HC*CCON
      DM(IR)=HD*DCON
      EM(IR)=HE*ECON
      CPLIM(ID)=CPBLK
      VOLM(IR)=VMN
      VRFTR(IT)=VMN
      SLOPE(IT,1)=SLOP1
      SLOPE(IT,2)=SLOP2
      NOTR(IT)=NNTN
      NINI(IT)=IR
      MIND(IR)=ID
      AT1(IT)=HA1
      BT1(IT)=HB1*BCON
      CT1(IT)=HC1*CCON
      DT1(IT)=HD1*DCON
      ET1(IT)=HE1*ECON
      HT1(IT)=HTRN1
      TT1(IT)=TTRN1
      VT1(IT)=VTR1
      WRITE(*,6971) NO,HA1,HB1,HC1,HD1,HE1,TTRN1,HTRN1,VTR1,SLOP1
      IF(NNTN.EQ.1) GO TO 450
      AT2(IT)=HA2
      BT2(IT)=HB2*BCON
      CT2(IT)=HC2*CCON
      DT2(IT)=HD2*DCON
      ET2(IT)=HE2*ECON
      HT2(IT)=HTRN2
      TT2(IT)=TTRN2
      VT2(IT)=VTR2
      WRITE(*,6971) NO,HA2,HB2,HC2,HD2,HE2,TTRN2,HTRN2,VTR2,SLOP2
      IF(NNTN.EQ.2) GO TO 450
      AT3(IT)=HA3
      BT3(IT)=HB3*BCON
      CT3(IT)=HC3*CCON
      DT3(IT)=HD3*DCON
      ET3(IT)=HE3*ECON
      HT3(IT)=HTRN3
      TT3(IT)=TTRN3
      VT3(IT)=VTR3
      SLOPE(IT,3)=SLOP3
      WRITE(*,6971)NO,HA3,HB3,HC3,HD3,HE3,TTRN3,HTRN3,VTR3,SLOP3
      IF(NNTN.EQ.3)  GO TO 450
      AT4(IT)=HA4
      BT4(IT)=HB4*BCON
      CT4(IT)=HC4*CCON
      DT4(IT)=HD4*DCON
      ET4(IT)=HE4*ECON
      HT4(IT)=HTRN4
      TT4(IT)=TTRN4
      VT4(IT)=VTR4
      SLOPE(IT,4)=SLOP4
      WRITE(*,6971)NO,HA4,HB4,HC4,HD4,HE4,TTRN4,HTRN4,VTR4,SLOP4
      IF(NNTN.EQ.4)  GO TO 450
      AT5(IT)=HA5
      BT5(IT)=HB5*BCON
      CT5(IT)=HC5*CCON
      DT5(IT)=HD5*DCON
      ET5(IT)=HE5*ECON
      HT5(IT)=HTRN5
      TT5(IT)=TTRN5
      VT5(IT)=VTR5
      SLOPE(IT,5)=SLOP5
      WRITE(*,6971) NO,HA5,HB5,HC5,HD5,HE5,TTRN5,HTRN5,VTR5,SLOP5
  450 CONTINUE
  400 CONTINUE
  401 CONTINUE
C
C     INCLUDE H2O IF SPECIFIED
C
      IF(NW.EQ.0) GO TO 350
      LNAME(IL,1)='WATE'
      LNAME(IL,2)='R   '
      WRITE(*,6983)
      AN(IL)=AQ(IL)
C
C     ASSIGN DUMMY INDEX TO H2O
C
      NID(IL)=69
  350 CONTINUE
      NIS=NM+1-NTR
      NIT=NM+NI-NTR
      NGS=NIT+1
      NGT=NM+NI+NG-NTR
      IF(IBUG.EQ.1) WRITE(*,*) ' EXITING LINEUP'
      RETURN
C
C
 1000 FORMAT (F5.0,I5,F5.0,I5,F5.0,I5,F5.0,I5,F5.0,I5,F5.0,I5,F5.0,I5
     1,F5.0,I5)
 1100 FORMAT(5X,F10.0)
 1200 FORMAT(4I5)
 1201 FORMAT(////4I5)
 1500 FORMAT(I4,5X,3A4,A3,5X,8A4,/,5X,4F15.0,/,5X,5F9.0,4F7.0)
 1600 FORMAT(I4,5X,3A4,A3,5X,8A4,/,5X,4F15.0,/,5X,5F9.0,4F7.0)
 2000 FORMAT(I4,1X,A4,A1,3F15.0/5X,4F15.0/5X,4F15.0)
 2500 FORMAT(I4,1X,5F9.0,4F7.0)
 6969 FORMAT(1X,I4,1X,4A4,8A4,2F11.1,2F8.3,5F8.3)
 6972 FORMAT(1X,I4,1X,4A4,8A4,2F11.1,F8.3,F8.1,5F8.3)
 6970 FORMAT(1X,I4,1X,A4,A1,2F10.1,F8.3,3F10.5,3F10.4,F10.4,F10.5)
 6971 FORMAT(12X,I4,2X,5F10.4,2F10.2,2F10.3)
 6975 FORMAT (1H1,50X,'.....  DATA ECHO  .....'//)
 7975 FORMAT (10X,'MINERALS'//)
 6976 FORMAT (/10X,'GASES'/)
 6977 FORMAT (/10X,'IONS'/)
 6978 FORMAT(/10X,'MINERALS WITH PHASE TRANSITIONS OR PSUEDO PHASE TRAN
     1SITIONS',/)
 6979 FORMAT(1X,'INDEX', 4X,'NAME',15X,'FORMULA',21X,'G (CAL)',4X,
     1'H (CAL)', 3X,'S (CAL)', 1X, 'V (CC)', 4X,'A', 4X,7HBX10**3,1X,
     18HCX10**-5,8HD*10**-3,7HE*10**5)
 6980 FORMAT(1X,'INDEX', 1X,'NAME',3X,'G (CAL)', 3X,'H (CAL)',2X,
     1'S (CAL)', 5X,'A1', 8X,'A2', 8X,'A3', 8X,'A4', 8X,'C1', 8X,'C2',
     2 5X,'THETA', 6X,'OMEGA')
 6981 FORMAT(12X,'INDEX', 7X,'A',5X,7HBX10**3,3X,8HCX10**-5,2X,
     18HD*10**-3,1X,7HE*10**5,6X,'TRAN T',4X,'TRAN H',3X,'TRAN V',
     2 4X,'SLOPE')
 6982 FORMAT(1X)
 6983 FORMAT(/10X,'LIQUID WATER.... (DATA TO BE CALCULATED)')
      END
      SUBROUTINE SUMREF(FLAGS)
C     ------------------------------------------------------------------
C     ------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/AQ/ A1(10),A2(10),A3(10),A4(10),THETA(10),ABAR(10),
     1CBAR(10),DBAR(10), OMEGA(10),HI(10),SI(10),GI(10),HIPT(10),
     2SIPT(10),GIPT(10),VIPT(10),CPIPT(10)
      COMMON/ELECT/ Q,U,W,X,Y,Z,N
      COMMON/IPRINT/NOPRIN
      COMMON/CP/NOCP
      COMMON/MN/AM(10),BM(10),CM(10),DM(10),EM(10),HM(10),SM(10),
     1GM(10),HMPT(10),SMPT(10),GMPT(10),VOLM(10),CPPT(10)
      COMMON/TRAN/AT1(10),BT1(10),CT1(10),DT1(10),ET1(10),
     1HT1(10),TT1(10),VT1(10),AT2(10),BT2(10),CT2(10),DT2(10),ET2(10),
     2HT2(10),TT2(10),VT2(10),AT3(10),BT3(10),CT3(10),DT3(10),ET3(10),
     3HT3(10),TT3(10),VT3(10),AT4(10),BT4(10),CT4(10),DT4(10),ET4(10),
     4HT4(10),TT4(10),VT4(10),AT5(10),BT5(10),CT5(10),DT5(10),ET5(10),
     5HT5(10),TT5(10),VT5(10),SLOPE(10,10),VRFTR(10),
     6NOTR(10),NINI(20),NTR
      COMMON/GZ/ AG(5),BG(5),CG(5),HG(5),SG(5),GG(5),HGPT(5),SGPT(5),
     1GGPT(5),VG(5),DG(5),EG(5)
      COMMON/COND/ P,TC,TK
      COMMON/NMBR1/NM,NI,NG,NW,NIT,NMT,NGT,NP,NPW
      COMMON/NMBR2/IL
      COMMON/SWIT/ KK
      COMMON/HEAD/TITL(10),LNAME(20,4),AN(20)
      COMMON/OMG/OMEGA5(10)
      COMMON/DEX/IND(20),CPLIM(20),MIND(10),IIND(10),IGND(10)
      COMMON /PNCH/ IPUN
      COMMON/FUG/ GFUG(5),GAMMO(5)
      COMMON/CRIT/ TCRIT(9),PCRIT(9)
      COMMON /CEX/ PQ,TTS,NRO
      COMMON/WET/GW,SW,HW,VW,CPW,CVW,AFUG,FUG
      COMMON/PRIN/ ICON,IGAS,ISW,NPT
      COMMON /KLOG/ RLOGK,HREAC
      COMMON/END/NCURV
      COMMON /IO/PLTUN,RXNUN,ICNUN,INPT
      COMMON/GASS/ANG(2),XCO2,GASCOF(2),ISOL
      COMMON/EKILL/ILBLNK,TEPS,PEPS,EPSI
      INTEGER PLTUN,RXNUN,ICNUN,TITLF,FLAGS(2),INPT
      COMMON/BUG/IBUG
      DIMENSION BH(10),CH(10),BZ(10),CZ(10),DZ(10),EZ(10),DH(10),
     1EH(10)
      IF(IBUG.EQ.1) WRITE(*,*) ' ENTERING SUMREF'
      IF(KK.EQ.1) GO TO 299
C
C     SET REF P T FOR H2O CALC BEFORE CALLING WATER
C
C     CHECK TO SEE IF PRESSURE IS GREATER THAN 10 KB TO CALL HYDRFN
C
C
      IGAS=0
      P=1.0
      TC=25.0
      TK=298.15
      NRO=2
      PQ=1.0
      TTS=25.0
      NP=0
      TITLF=0
  299 CONTINUE
      ISTM=0
      DO 20 I=1,NG
      IF(IND(NM-NTR+NI+I).EQ.1301)ISTM=1
      IF(ISTM.EQ.1.AND.P.LE.10000.)GO TO 51
      IF(ISTM.EQ.1.AND.P.GT.10000.)GO TO 510
   20 CONTINUE
      IF(NW.EQ.0) NP=0
        IF(NW.EQ.1.AND.P.GT.10000..AND.ICON.EQ.2) NP=1
          IF(NW.EQ.1.AND.P.EQ.10000.) GO TO 51
      IF(NW.EQ.1.AND.NP.EQ.0) GO TO 51
      IF(NW.EQ.1.AND.NP.EQ.1) GO TO 510
      IF(NI.GE.1) GO TO 51
      GO TO 52
C     ------------------------------------------------------------------
   51 CALL WATER
C     ------------------------------------------------------------------
      GO TO 52
C     ----------------------------------------------------------------
 510  CALL HYDRFN
      IF(ISTM.EQ.1)CALL FUGAFN
C     ----------------------------------------------------------------
   52 CONTINUE
      IF(NM.EQ.0) GO TO 61
C     ------------------------------------------------------------------
      CALL MINERL
C     ------------------------------------------------------------------
   61 CONTINUE
      IF(NI.EQ.0) GO TO 70
C     ------------------------------------------------------------------
      CALL IONS
C     ------------------------------------------------------------------
   70 CONTINUE
      IF(NG.EQ.0) GO TO 81
      IGAS=1
C     ------------------------------------------------------------------
      CALL GAS
C     ------------------------------------------------------------------
   81 CONTINUE
      IF(KK.EQ.1) GO TO 999
C     ------------------------------------------------------------------
C     PRINT INPUT DATA
C     ------------------------------------------------------------------
      WRITE(3,300)
     1           (TITL(I),I=1,10)
  300 FORMAT('1',20X,10A8,/,5X,100('-'))
      WRITE(3,305)
  305 FORMAT(     25X,'SPECIES PROPERTIES IN THEIR STANDARD STATE OF 25
     1DEGREES C AND 1 BAR',/, 5X,100('-'), // , 45X,'.....MINERALS....
     2.')
      IF(NM.EQ.0) GO TO 301
      WRITE(3,310)
  310 FORMAT(/,101X,'MAIER-KELLEY POWER FUN. COEF.', /,  5X,'NAME',10X,
     1'COEF.',7X,'H (CAL)',6X,'S (CAL)',6X,'G (CAL)'
     2,4X,'V (CC/MOL)', 6X,'A', 7X,'BX10**3', 4X,'CX10**-5',
     33X,'DX10**-3',2X,'EX10**5')
      WRITE(3,315)
  315 FORMAT(5X,'----',10X,'-----',6X,'---------',5X,'---------',4X,
     1'---------',2X,'----------',4X,'-----',5X,'---------',
     22X,'--------',
     23X,'--------',2X,'-------')
      DO 416  I=1,NM
      BH(I)=BM(I)*1000.0
      CH(I)=CM(I)*0.00001
      DH(I)=DM(I)*.001
      EH(I)=EM(I)*100000.
      J=MIND(I)
      WRITE(3,316)LNAME(J,1),LNAME(J,2),
     3   LNAME(J,3),LNAME(J,4),AN(J),HM(I),SM(I),GM(I),VOLM(I)
     2,AM(I),BH(I),CH(I),DH(I),EH(I)
      IF(NTR.LT.1) GO TO 416
      IF(IND(J).GE.1500.AND.IND(J).LT.1600)  GO TO 77
      GO TO 416
   77 CONTINUE
      ISEND=I
      CALL TIND(ITR,ISEND)
      BY=BT1(ITR)*1000.0
      CY=CT1(ITR)*0.00001
      DY=DT1(ITR)*.001
      EY=ET1(ITR)*100000.
      SZ =HT1(ITR)/TT1(ITR)
      TRN1=TT1(ITR)-273.15
      IF(NOTR(ITR).EQ.1) GO TO 76
      BZ2=BT2(ITR)*1000.0
      CZ2=CT2(ITR)*0.00001
      DZ2=DT2(ITR)*.001
      EZ2=ET2(ITR)*100000.
      SZZ=HT2(ITR)/TT2(ITR)
      TRN2=TT2(ITR)-273.15
      IF(NOTR(ITR).LE.2)  GO TO 76
      BZ3=BT3(ITR)*1000.0
      CZ3=CT3(ITR)*0.00001
      DZ3=DT3(ITR)*.001
      EZ3=ET3(ITR)*100000.
      SZ3=HT3(ITR)/TT3(ITR)
      TRN3=TT3(ITR)-273.15
      IF(NOTR(ITR).LE.3)  GO TO 76
      BZ4=BT4(ITR)*1000.0
      CZ4=CT4(ITR)*0.00001
      DZ4=DT4(ITR)*.001
      EZ4=ET4(ITR)*100000.
      SZ4=HT4(ITR)/TT4(ITR)
      TRN4=TT4(ITR)-273.15
      IF(NOTR(ITR).LE.4)  GO TO 76
      BZ5=BT5(ITR)*1000.0
      CZ5=CT5(ITR)*0.00001
      DZ5=DT5(ITR)*.001
      EZ5=ET5(ITR)*100000.
      SZ5=HT5(ITR)/TT5(ITR)
      TRN5=TT5(ITR)-273.15
   76 CONTINUE
      WRITE(3,939) HT1(ITR),SZ,
     1 TRN1,VT1(ITR),AT1(ITR),BY,CY,DY,EY
      IF(NOTR(ITR).GE.2) WRITE(3,938) HT2(ITR),SZZ,TRN2,VT2(ITR),
     1AT2(ITR),BZ2,CZ2,DZ2,EZ2
      IF(NOTR(ITR).GE.3) WRITE(3,937) HT3(ITR),SZ3,TRN3,VT3(ITR),
     1AT3(ITR),BZ3,CZ3,DZ3,EZ3
      IF(NOTR(ITR).GE.4) WRITE(3,936) HT4(ITR),SZ4,TRN4,VT4(ITR),
     1AT4(ITR),BZ4,CZ4,DZ4,EZ4
      IF(NOTR(ITR).GE.5) WRITE(3,935) HT5(ITR),SZ5,TRN5,VT5(ITR),
     1AT5(ITR),BZ5,CZ5,DZ5,EZ5
  939 FORMAT( 1X,'--FIRST TRAN--', 14X,F10.2,F10.2,6X,'TEMP=',F6.1,
     1F10.5,2X,F10.3, F10.4,1X,F10.3,4X,F9.3,1X,F9.3)
  938 FORMAT( 1X,'-- SEC TRAN --', 14X,F10.2,F10.2,6X,'TEMP=',F6.1,
     1 F10.5,2X,F10.3,F10.4,1X,F10.3,4X,F9.3,1X,F9.3)
  937 FORMAT( 1X,'--THIRD TRAN--', 14X,F10.2,F10.2,6X,'TEMP=',F6.1,
     1 F10.5,2X,F10.3,F10.4,1X,F10.3,4X,F9.3,1X,F9.3)
  936 FORMAT( 1X,'-- FOUR TRAN--', 14X,F10.2,F10.2,6X,'TEMP=',F6.1,
     1 F10.5,2X,F10.3,F10.4,1X,F10.3,4X,F9.3,1X,F9.3)
  935 FORMAT( 1X,'--FIFTH TRAN--', 14X,F10.2,F10.2,6X,'TEMP=',F6.1,
     1 F10.5,2X,F10.3,F10.4,1X,F10.3,4X,F9.3,1X,F9.3)
  416 CONTINUE
  301 CONTINUE
      IF(NI.EQ.0) GO TO 303
      WRITE(3,325)
  316 FORMAT(1X,3A4,A3,1X,F7.3,3X,F10.0,3X,F10.3, 3X,F10.0, 3X,
     $F10.5,2X,F10.3,F10.4,1X,F10.3,3X,2(1X,F9.3))
  325 FORMAT( /,48X,'.....IONS.....',/)
      WRITE(3,330)
  330 FORMAT(  3X, 'NAME',12X,'COEF.',3X,'ENTHALPY (CAL)', 3X,'ENTROPY (
     2CAL)', 3X,'FREE ENERGY (CAL)', 3X,'VOLUME (CC/MOL)',
     1      /,3X,'----',12X,'-----', 3X,'--------------', 3X, '---------
     1----', 3X,'-----------------', 3X,'---------------')
C
      DO 777 I=1,NI
      JJ=IIND(I)
      WRITE(3,331)
     1 LNAME(JJ,1),LNAME(JJ,2),AN(JJ),HI(I),SI(I),GI(I),VIPT(I)
  777 CONTINUE
  331 FORMAT( 1X,2A4, 8X,F7.3,  5X,F10.1, 4X, F10.1,10X,F10.1, 9X,
     1F10.4)
      WRITE(3,355)
  355 FORMAT(  /,  3X,'NAME',14X,'A1',13X,'A2',12X,'A3',12X,'A4', 9X,
     1'OMEGA', 9X,'THETA',10X,'C1',12X,'C2', /, 3X,'----',14X,'--',13X,
     1 '--',12X,'--',12X,'--', 9X,'-----', 9X,'-----',10X,'--',12X,'--')
C
      DO 776 I=1,NI
      JJ=IIND(I)
      WRITE(3,356) LNAME(JJ,1),LNAME(JJ,2),
     1            A1(I),A2(I),A3(I),A4(I),OMEGA5(I),THETA(I),ABAR(I),
     1 CBAR(I)
  776 CONTINUE
  356 FORMAT(1X,A4,A1,10X,8(E12.5, 2X))
  303 CONTINUE
      IF(NG.EQ.0) GO TO 302
      WRITE(3,320)
  320 FORMAT(/, 47X,'.....GASES.....',/)
      WRITE(3,310)
      WRITE(3,315)
      DO 417 I=1,NG
      BZ(I)=BG(I)*1000.0
      DZ(I)=DG(I)*.001
      EZ(I)=EG(I)*100000.
  417 CZ(I)=CG(I)*0.00001
C
      AGVOL=0.0
      DO 778 I=1,NG
      JJ=IGND(I)
      WRITE(3,316)LNAME(JJ,1),LNAME(JJ,2),
     1 LNAME(JJ,3),LNAME(JJ,4),AN(JJ),HG(I),SG(I),GG(I),AG
     1VOL,AG(I),BZ(I),CZ(I),DZ(I),EZ(I)
  778 CONTINUE
C
  302 CONTINUE
      IF(NW.EQ.0) GO TO 333
      WRITE(3,326)
  326 FORMAT(/  ,48X,'.....H2O.....',/)
      WRITE(3,330)
      WRITE(3,331) LNAME(IL,1),LNAME(IL,2),AN(IL),HW,SW,GW,VW
      IF(NPW.NE.1) GO TO 333
  334 WRITE(3,382)
  382 FORMAT(/,13X,'..... HIGH PRESSURE H2O PROPERTIES HAVE BEEN USED AB
     1OVE 10 KB .....')
  333 CONTINUE
C     ------------------------------------------------------------------
C     SUM REACTION PROPERTIES
C     ------------------------------------------------------------------
      IF(NI.NE.0) GO TO 861
      WRITE(3,360)
  360 FORMAT(// , 5X,100('-'),
     1           /, 35X,'REACTION PROPERTIES AT 25 DEGREES C AND 1 BAR',
     1/, 5X,100('-'),/
     1//  , 5X,'ENTHALPY (CAL)',  5X,'ENTROPY (CAL)',  6X,'FREE ENERGY (
     3CAL)', 3X,'DELTA VOL (CC/MOL)'
     4                       ,  4X,'HEAT CAPACITY', 11X,' LN K')
      GO TO 999
  861 CONTINUE
      WRITE(3,361)
  361 FORMAT(// , 5X,100('-'),
     1           /, 35X,'REACTION PROPERTIES AT 25 DEGREES C AND 1 BAR',
     1/, 5X,100('-'),/
     1//  , 5X,'ENTHALPY (CAL)',  5X,'ENTROPY (CAL)',  6X,'FREE ENERGY (
     3CAL)', 3X,'DELTA VOL (CC/MOL)'
     4                       ,  4X,'HEAT CAPACITY', 11X,'LOG K')

  999 CONTINUE
      AL=ALOG(10.0)
      R=1.9872
      HREAC=0.0
      SREAC=0.0
      GREAC=0.0
      VREAC=0.0
      CPREAC=0.0
      DO 10 I=1,IL
      NIX=NM-NTR
      IF(I.GT.NIX) GO TO 11
      HREAC=HREAC+AN(I)*HMPT(I)
      SREAC=SREAC+AN(I)*SMPT(I)
      GREAC=GREAC+AN(I)*GMPT(I)
      CPREAC=CPREAC+AN(I)*CPPT(I)
      VREAC=VREAC+AN(I)*VOLM(I)
      GO TO 10
   11 CONTINUE
      IF(I.GT.NIT) GO TO 12
      J=I-NIX
      HREAC=HREAC+AN(I)*HIPT(J)
      SREAC=SREAC+AN(I)*SIPT(J)
      GREAC=GREAC+AN(I)*GIPT(J)
      CPREAC=CPREAC+AN(I)*CPIPT(J)
      VREAC=VREAC+AN(I)*VIPT(J)
      GO TO 10
   12 CONTINUE
      IF(I.GT.NGT) GO TO 13
      J=I-NI-NIX
      SREAC=SREAC+AN(I)*SGPT(J)
      HREAC=HREAC+AN(I)*HGPT(J)
      GREAC=GREAC+AN(I)*GGPT(J)
      CPREAC=CPREAC+AN(I)*(AG(J)+BG(J)*TK+CG(J)/TK**2.0+DG(J)/DSQRT(TK)
     1+EG(J)*TK*TK)
      GO TO 10
   13 CONTINUE
      NIX=NGT+NTR
      IF(I.GT.NIX) GO TO 14
C
C     THIS LOOP FOR TRANSITION MIN WHICH ARE LOADED IN LINEUP AFTER GAS
C
      J=I+NM-NTR-NGT
      HREAC=HREAC+AN(I)*HMPT(J)
      SREAC=SREAC+AN(I)*SMPT(J)
      GREAC=GREAC+AN(I)*GMPT(J)
      CPREAC=CPREAC+AN(I)*CPPT(J)
      VREAC=VREAC+AN(I)*VOLM(J)
      GO TO 10
   14 CONTINUE
      IF(NW.EQ.0) GO TO 10
      SREAC=SREAC+AN(I)*SW
      HREAC=HREAC+AN(I)*HW
      GREAC=GREAC+AN(I)*GW
      CPREAC=CPREAC+AN(I)*CPW
      VREAC=VREAC+AN(I)*VW
   10 CONTINUE
      RLOGK=-GREAC/(R*TK)
      IF(NI.NE.0.AND.NOPRIN.EQ.0) RLOGK=RLOGK/2.303
      RLGK=DABS(RLOGK)
       IF(KK.EQ.0) GO TO 785
          IF(NCURV.EQ.1.AND.NOPRIN.EQ.1) THEN
                IF(IBUG.EQ.1) WRITE(*,*) ' EXITING SUMREF'
                IF(IBUG.EQ.1) WRITE(*,*)' P,T,LN/LOG K= ',P,TC,RLOGK
                RETURN
          END IF
C ADDED TO PRINT AFTER INTHEF2 FINDS T
          IF(NCURV.NE.0.AND.NOPRIN.EQ.0) GO TO 866
      IF(NW.EQ.0) GO TO 23
      IF(NW.EQ.1.AND.NP.EQ.0) GO TO 22
      IF(NP.EQ.1.AND.NCURV.EQ.0) GO TO 220
      IF(NOPRIN.EQ.0) GO TO 220
      FUG=0.
      GO TO 22
  220 CALL FUGAFN
   22 FUGAS=FUG
   23 CONTINUE
        CALL DOTZ
      IF(KK.EQ.1) GO TO 997
 785  WRITE(3,365)
     1           HREAC, SREAC, GREAC, VREAC, CPREAC, RLOGK
  365 FORMAT(/  , 3X,6(E14.6,6X))
       IF(NG.NE.0) WRITE(3,63721)
63721   FORMAT(//,30X,'FUGACITY COEFFICENTS ARE LISTED IN THIS',
     1' ORDER')
      IF(NCURV.EQ.0) CALL TITLE(TITLF)
      GO TO 998
  997 IF(ISW.EQ.1) CALL TITLE(TITLF)
C     SET CP TO ZERO
      DO 500 II=1,IL
      IF(IND(II).EQ.69)  GO TO 500
      IF(IND(II).GT.1600.AND.IND(II).LT.1700)  GO TO 500
C	commented out 15 April, 1984 (cem) so all Cp values printed in output.
C      IF(CPLIM(II).LT.TK)  NOCP=1
  500 CONTINUE
      IF(NI.EQ.0)GO TO 611
      IF(ILBLNK.EQ.1)GO TO 203
C     WRITE(*,210) TEPS,PEPS,EPSI
C 200 FORMAT(//' DIELECTRIC CONST AT ',F7.1,' DEG AND ',F8.2,' KB IS: ',
C    1 F8.3)
      GO TO 611
  203 WRITE(3,210) TEPS,PEPS,EPSI
  210 FORMAT(//' OUT OF FIR REGION.  NEW DIELECTRIC CONSTANT NOT CALC'
     1/'LAST VALUE AT ',F7.1,' DEG. AND ',F8.2, ' KB. E= ',F8.3)
  611 CONTINUE
      IF(NG.NE.0) GO TO 801
      IF(IGAS.NE.0.OR.NW.NE.0)GO TO 622
  619 IF(NP.EQ.0.AND.NOCP.EQ.0) GO TO 620
C      IF(NP.EQ.1.AND.P.GT.10000.) GO TO 621
C          IF(NOCP.EQ.1)GO TO 621
  620 WRITE(3,345) P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,VREAC
C##### extra write statement added, 9 oct 85 (crk) for plotfile
      WRITE(PLTUN,804) P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,VREAC
      GO TO 130
C*****commented out 15 April, 1984 (cem) so all Cp values printed in output.
C  621 WRITE(3,344) P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,VREAC
C      GO TO 130
C  344 FORMAT(/,1X,F9.3,5X,F9.1,19X,5(E16.6))
  622 IF(NP.EQ.0.AND.NOCP.EQ.0) GO TO 623
C*****commented out 15 April, 1984 (cem) so all Cp values printed in output.
C     IF(NP.EQ.1.AND.P.GT.10000.) GO TO 624
C          IF(NOCP.EQ.1) GO TO 624
  623 WRITE(3,346)P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,VREAC,FUGAS
C##### extra write statement added, 9 oct 85 (crk) for plotfile
      WRITE(PLTUN,804)P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,VREAC,FUGAS
      GO TO 130
C*****commented out 15 April, 1984 (cem) so all Cp values printed in output.
C 624 WRITE(3,347)P,TC,HREAC,SREAC,GREAC,RLOGK,VREAC,FUGAS
C 347 FORMAT(/,1X,F9.3,4X,F9.1,18X,6(E15.6))
  346 FORMAT( /,1X,F9.3,4X,F9.1,3X,7(E15.6))
  345 FORMAT(/,  1X, F9.3, 5X,F9.1, 3X,6(E16.6))
C     GO TO 130
C##### block IF added to accomodate extra write statement, 9 oct 85 (crk)
  801     IF(NP.EQ.0.AND.NOCP.EQ.0) THEN
              WRITE(3,802) P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,
     1            VREAC,(GAMMO(I),I=1,NG)
C##### extra write statement added, 9 oct 85 (crk) for plotfile
              WRITE(PLTUN,804) P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,
     1            VREAC,(GAMMO(I),I=1,NG)
          END IF
      GO TO 998
  866 WRITE(3,802) P,TC,CPREAC,HREAC,SREAC,GREAC,RLOGK,
     1            VREAC,(GAMMO(I),I=1,NG)
C     IF(NCURV.NE.0.AND.ISOL.EQ.3) THEN
C             IF(GAMMO(1).EQ.GASCOF(1)) XXXGAS=GASCOF(2)
C             IF(GAMMO(1).EQ.GASCOF(2)) XXXGAS=GASCOF(1)
C             WRITE(3,805) XXXGAS
C     END IF
C 805 FORMAT(100X,' OTHER (H2O/CO2) GAS=  ',E10.4)
C*****commented out 15 April, 1984 (cem) so all Cp values printed in output.
C         IF(NP.EQ.1.OR.NOCP.EQ.1)
C    4              WRITE(3,803) P,TC,HREAC,SREAC,GREAC,RLOGK,VREAC,
C    1( GAMMO(I),I=1,NG)
  802 FORMAT(/,1X,F9.3,4X,F9.1,2X,6(E16.6),1X,E10.4,4(/,122X,E10.4))
  803 FORMAT(/,1X,F9.3,4X,F9.1,18X,5(E16.6),1X,E10.4,4(/,122X,E10.4))
  804 FORMAT(1X,2F7.1,11(E12.4))
  130 CONTINUE
  998 CONTINUE
C
C     SET IPUN = 1 TO PUNCH LOG K VALUES FOR DIAGRAM
C     SET IPUN = 2 TO PUNCH FREE ENERGY FOR EQUILAS
C     SET IPUN = 3 TO PUNCH THERMO PROPRETIES OF REACTION
C
C##### changed PUNCH to WRITE and GOTOs to block IF, 2 Mar 86
C      all files should have been opened by the main program.  --crk
      IF(IPUN.EQ.1.OR.FLAGS(1).NE.0) THEN
         I=1
         IF(IND(1).GE.1200) I=IL
         IF(IND(IL).EQ.69.AND.IND(1).GE.1200) I=IL-1
CJDW     WRITE(04,1000) LNAME(I,1),LNAME(I,2),IND(I),P,TC,RLOGK
      ELSE IF(IPUN.EQ.2.OR.FLAGS(2).NE.0)THEN
CJDW     WRITE(15,1001) (TITL(I),I=1,3),P,TC,GREAC
      END IF
C     IF(IPUN.EQ.3)PUNCH 1001,(TITL(I),I=1,3),P,TC,GREAC,TITL(1),P,TC,
C    1HREAC,SREAC,VREAC,CPREAC
 1000 FORMAT(A10,A6,3X,I4,7X,F9.3,1X,F6.2,1X,E14.7)
 1001 FORMAT(3A8,F9.3,F6.2,E14.7,/,A10,F9.3,F6.2,4E13.5)
C
      IF(ICON.NE.6) GO TO 1010
      IF(NI.NE.0) WRITE(*,1011) P,TC,GREAC,RLOGK
      IF(NI.EQ.0) WRITE(*,1012) P,TC,GREAC,RLOGK
 1011 FORMAT(' P= ',F8.2,'  T= ',F8.2,'  dG= ',E14.7,'  lnK= '
     1,E14.7)
 1012 FORMAT(' P= ',F8.2,'  T= ',F8.2,'  dG= ',E14.7,' LogK= '
     1,E14.7)
 1010 CONTINUE
      IF(IBUG.EQ.1) THEN
                WRITE(*,*) '       EXITING SUMREF'
                WRITE(*,*)' P,T,LN/LOG K= ',P,TC,RLOGK
                RETURN
          END IF
      END
      SUBROUTINE TIND(IT,IR)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/HEAD/TITL(10),LNAME(20,4),AN(20)
      COMMON/OMG/OMEGA5(10)
      COMMON/DEX/IND(20),CPLIM(20),MIND(10),IIND(10),IGND(10)
      COMMON /PNCH/ IPUN
      COMMON/TRAN/AT1(10),BT1(10),CT1(10),DT1(10),ET1(10),
     1HT1(10),TT1(10),VT1(10),AT2(10),BT2(10),CT2(10),DT2(10),ET2(10),
     2HT2(10),TT2(10),VT2(10),AT3(10),BT3(10),CT3(10),DT3(10),ET3(10),
     3HT3(10),TT3(10),VT3(10),AT4(10),BT4(10),CT4(10),DT4(10),ET4(10),
     4HT4(10),TT4(10),VT4(10),AT5(10),BT5(10),CT5(10),DT5(10),ET5(10),
     5HT5(10),TT5(10),VT5(10),SLOPE(10,10),VRFTR(10),
     6NOTR(10),NINI(20),NTR
      COMMON/BUG/IBUG
      IF(IBUG.EQ.1) WRITE(*,*) ' ENTERING TIND'
C
C     RETURNS A VALUE OF THE TRANS MINERAL COUNTER FOR THE VALUE
C     OF THE MINERAL COUNTER
C
      DO 10 N=1,NTR
      IF(NINI(N).NE.IR)  GO TO 10
    7 CONTINUE
      IT=N
      GO TO 99
   10 CONTINUE
      IT=-1
      WRITE(3,1000)IR,NTR
   99       IF(IBUG.EQ.1) WRITE(*,*) '       EXITING  TIND'
      RETURN
 1000 FORMAT(10X,17HINDEX ERROR-- THE,I5,46HTH MINERAL IS NOT A TRANSITI
     AO  N PHASE -- NTR=,I5,/)
      END
      SUBROUTINE UNIV(ISTP)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/COND/ P,TC,TK
      COMMON/NMBR1/NM,NI,NG,NW,NIT,NMT,NGT,NP,NPW
      COMMON/NMBR2/IL
      COMMON/CEX/PQ,TCENT,NRO
      COMMON/IO/PLTUN,RXNUN,ICNUN,INPT
      COMMON/GASS/ANG(2),XCO2,GASCOF(2),ISOL
      COMMON/INT2/NTHRU,XMIN,XINC,XMAX
      COMMON/DAT/NECHO
      COMMON/EKILL/ILBLNK,TEPS,PEPS,EPSI
      COMMON/BUG/IBUG
      INTEGER PLTUN,RXNUN,ICNUN,TITLF,INPT
      IF(IBUG.EQ.1) WRITE(*,*) ' ENTERING UNIV'
      TITLF=0
      NTHRU=0
      NRO=2
      NPM=0
      NC=0
      IF(INPT.EQ.1) GO TO 31
      WRITE(*,1000)
 1000 FORMAT(' CALCULATE T(EQ) AT SPECIFIED P. ICON MUST=1'///)
      WRITE(*,1010)
 1010 FORMAT(' SET PMIN,PMAX,PINC(BARS),TMIN,TMAX (DEGREES C), AND'
     1' LN K (NON-GAS)  AS REAL NUMBERS'/
     2' **** 325.0<T<1050.0 FOR CO2 (& H2O) USING KERRICK'/
     3' AND JACOBS SUBROUTINE IN SUPCRIT  ****'/)
      READ(*,*) PMIN,PMAX,PINC,X1SAV,X2SAV,ALOGK
      GOTO 32
   31 CONTINUE
      READ(RXNUN,*) PMIN,PMAX,PINC,X1SAV,X2SAV,ALOGK
   32 CONTINUE
      WRITE(3,855) ALOGK
  855 FORMAT(/' LN K(SOLIDS)= ',F8.4)
      PPMAX=PMAX
      IF(NW.EQ.1.AND.PMAX.GT.10000.) GO TO 60
      GO TO 66
   60 PMAX=10000.
      NPM=1
   66 CONTINUE
      P=PMIN-PINC
      IF (NG .GT. 0) IGAS=1
      IF (NG .EQ. 0) IGAS=0
      CALL TITLE(TITLF)
 10   CONTINUE
      P=P+PINC
      X1=X1SAV
      X2=X2SAV
      NC=NC+1
      IF(NC.EQ.2.AND.PMIN.LT.10.0) P=P-1.0
      IF(P.GT.PMAX.AND.NPM.EQ.0) GO TO 99
      IF(P.GT.PPMAX.AND.NP.EQ.1) GO TO 99
      IF(P.GT.PMAX.AND.NPM.EQ.1) GO TO 98
      GO TO 462
   98 PMAX=PPMAX
      NP=1
  462 CONTINUE
      PQ=P
      PQQ=P/1000.0
      IF(NECHO.EQ.0)GO TO 63
      WRITE(*,300)P
   63 CONTINUE
  300 FORMAT(' P=',F8.1,' BARS')
      IF(ISOL.NE.1) GO TO 50
      CALL INTHEF (F1,F2,X1,X2,FRT,XRT,ALOGK)
      XRTC=XRT
      WRITE(PLTUN,350)XRTC,P
  350 FORMAT(F7.1,3X,F7.1)
      GO TO 55
   50 CALL INTHF2(FCTN1,FCTN2,X1,X2,FRT,XRT,ALOGK)
   55 CONTINUE
      GO TO 10
  99  ISTP=1
      IF(IBUG.EQ.1) WRITE(*,*) '       EXITING UNIV'
      RETURN
  100 FORMAT(8F10.0)
  200 FORMAT(7I5)
      END
